package com.tianyi.service.impl;

import com.tianyi.service.FileGetResourceService;
import org.springframework.stereotype.Service;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

@Service
public class FileGetResourceServiceImpl implements FileGetResourceService {

    @Override
    public void getFile(String fileName, HttpServletResponse response) {
        String filePath = "/home/ofd/ofddir/" + fileName;

        // 设置响应头，通知浏览器以附件形式下载
        response.setHeader("Content-Disposition", "attachment; filename=\"" + getFileName(filePath) + "\"");
        response.setContentType("application/octet-stream");

        try (FileInputStream fis = new FileInputStream(filePath); ServletOutputStream sos = response.getOutputStream()) {
            byte[] buffer = new byte[1024];
            int bytesRead;
            while ((bytesRead = fis.read(buffer)) != -1) {
                sos.write(buffer, 0, bytesRead);
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private String getFileName(String filePath) {
        // 从路径中提取文件名
        return filePath.substring(filePath.lastIndexOf(File.separator) + 1);
    }
}
